local joker_effect_table = {
	"none",
	"random",
	"fire_head",
	"fire_head_usual",
	"flyes_plague",
	"glowing_eyes",
	"glowing_eyes_and_smoke",	
	"mega_alien_eyes",
	"mega_kawaii_eyes",
	"mega_rad_mutant_eyes",
	"moneyburn",
	"smoke_distorted",
	"smoking_head",
}

local joker_effect_table_color = {
	"random",
	"green",
	"blue",
	"cyan",
	"pink",
	"purple",
	"red",
	"white",
	"yellow",
}

local joker_effect_table_attach_to_spine = {
	"moneyburn",
	"smoke_distorted",
}

local joker_effect_table_no_color = {
	"moneyburn",
	"flyes_plague",
	"mega_kawaii_eyes",
	"fire_head_usual"
}

local joker_effect_table_eye_effects = {
	"glowing_eyes",
	"glowing_eyes_and_smoke",	
	"mega_alien_eyes",
	"mega_rad_mutant_eyes",
}

-- Effect positions
local effect_pos_no_gear = Vector3(0,0,-3)
local effect_pos_low = Vector3(0,-3,0)
-- Tables below need for LPF effect handling
local resmod_units_no_gear = { 
	"cop",
	"fbi",
	"hrt",
	"swat",
	-- for LPF mutator
	"hrt_titan",
	"fbi_vet",
	"security",
	"gensec_guard",
	"city_swat_guard"		
}

local resmod_units_low = { -- Zeal heavies and grenadier need lower effect position
	Idstring("units/pd2_dlc_gitgud/characters/ene_grenadier_1/ene_grenadier_1"),
	Idstring("units/pd2_dlc_gitgud/characters/ene_grenadier_1/ene_grenadier_1_husk"),
	Idstring("units/pd2_dlc_gitgud/characters/ene_zeal_swat_heavy_sc/ene_zeal_swat_heavy_sc"),
	Idstring("units/pd2_dlc_gitgud/characters/ene_zeal_swat_heavy_sc/ene_zeal_swat_heavy_sc_husk"),
	Idstring("units/pd2_dlc_gitgud/characters/ene_zeal_swat_heavy_r870_sc/ene_zeal_swat_heavy_r870_sc"),
	Idstring("units/pd2_dlc_gitgud/characters/ene_zeal_swat_heavy_r870_sc/ene_zeal_swat_heavy_r870_sc_husk"),
	Idstring("units/pd2_mod_halloween/characters/ene_grenadier_1/ene_grenadier_1"),
	Idstring("units/pd2_mod_halloween/characters/ene_grenadier_1/ene_grenadier_1_husk"),
	Idstring("units/pd2_mod_halloween/characters/ene_zeal_swat_heavy_sc/ene_zeal_swat_heavy_sc"),
	Idstring("units/pd2_mod_halloween/characters/ene_zeal_swat_heavy_sc/ene_zeal_swat_heavy_sc_husk"),
	Idstring("units/pd2_mod_halloween/characters/ene_zeal_swat_heavy_r870_sc/ene_zeal_swat_heavy_r870_sc"),
	Idstring("units/pd2_mod_halloween/characters/ene_zeal_swat_heavy_r870_sc/ene_zeal_swat_heavy_r870_sc_husk")
}

local resmod_hrt_exclude_list = { -- for HRT enemies where usual effect position will be better
	Idstring("units/pd2_dlc_gitgud/characters/ene_zeal_fbi_m4/ene_zeal_fbi_m4"),
	Idstring("units/pd2_dlc_gitgud/characters/ene_zeal_fbi_m4/ene_zeal_fbi_m4_husk"),
	Idstring("units/pd2_dlc_gitgud/characters/ene_zeal_fbi_mp5/ene_zeal_fbi_mp5"),
	Idstring("units/pd2_dlc_gitgud/characters/ene_zeal_fbi_mp5/ene_zeal_fbi_mp5_husk"),
	Idstring("units/pd2_mod_halloween/characters/ene_zeal_fbi_m4/ene_zeal_fbi_m4"),
	Idstring("units/pd2_mod_halloween/characters/ene_zeal_fbi_m4/ene_zeal_fbi_m4_husk"),
	Idstring("units/pd2_mod_halloween/characters/ene_zeal_fbi_mp5/ene_zeal_fbi_mp5"),
	Idstring("units/pd2_mod_halloween/characters/ene_zeal_fbi_mp5/ene_zeal_fbi_mp5_husk")
}

local resmod_murky_no_gear = { -- Majority of murky units looks better with "no_gear" effect position
	Idstring("units/pd2_mod_sharks/characters/ene_fbi_swat_1/ene_fbi_swat_1"),
	Idstring("units/pd2_mod_sharks/characters/ene_fbi_swat_1/ene_fbi_swat_1_husk"),
	Idstring("units/pd2_mod_sharks/characters/ene_fbi_swat_2/ene_fbi_swat_2"),
	Idstring("units/pd2_mod_sharks/characters/ene_fbi_swat_2/ene_fbi_swat_2_husk"),
	Idstring("units/pd2_mod_sharks/characters/ene_city_swat_2/ene_city_swat_2_husk"),
	Idstring("units/pd2_mod_sharks/characters/ene_zeal_city_1/ene_zeal_city_1"),
	Idstring("units/pd2_mod_sharks/characters/ene_zeal_city_1/ene_zeal_city_1_husk"),
	Idstring("units/pd2_mod_sharks/characters/ene_zeal_city_2/ene_zeal_city_2"),
	Idstring("units/pd2_mod_sharks/characters/ene_zeal_city_2/ene_zeal_city_2_husk"),
	Idstring("units/pd2_mod_sharks/characters/ene_zeal_city_3/ene_zeal_city_3"),
	Idstring("units/pd2_mod_sharks/characters/ene_zeal_city_3/ene_zeal_city_3_husk")
}

function CopBase:get_Joker_Effect()			
	local effect_id_string_data = {0,0,0}
	
	local joker_effect = joker_effect_table[JokerEffect.Options:GetValue("JokerEffect_effect")]
	if joker_effect == "random" then
		local effect_index = math.random(3, 12)
		joker_effect = joker_effect_table[effect_index]
	end
	
	local get_obj = Idstring("Head")	
	if table.contains(joker_effect_table_attach_to_spine, joker_effect) then
		get_obj = Idstring("Spine2")
	end
	
	local attach_to_unit = self._unit:get_object(get_obj)
	if not attach_to_unit then
		return
	end
	
	local effect_color = joker_effect_table_color[JokerEffect.Options:GetValue("JokerEffect_effect_color")]
	if effect_color == "random" then
		local color_index = math.random(2, 9)
		effect_color = joker_effect_table_color[color_index]
	end
	
	if table.contains(joker_effect_table_no_color, joker_effect) then
		joker_effect_id_string = Idstring("effects/joker_effects/"..joker_effect)
	else
		joker_effect_id_string = Idstring("effects/joker_effects/"..effect_color.."/"..joker_effect)
	end
	
	local effect_pos = Vector3(0,0,0)
	local effect_adjustment = JokerEffect.Options:GetValue("JokerEffect_effect_adjustments")
	
	if effect_adjustment and table.contains(joker_effect_table_eye_effects, joker_effect) then
		if self._unit:base()._tweak_table == "security"  or self._unit:base()._tweak_table == "security_mex" then
			effect_pos = Vector3(0,0,-2)
		end 
		
		if self._unit:base()._tweak_table == "heavy_swat"  or self._unit:base()._tweak_table == "fbi_heavy_swat" then
			if faction == "america" or faction == "zombie" or faction == "federales" then
				effect_pos = Vector3(0,0,5)
			elseif faction == "murkywater" then
				effect_pos = Vector3(0,0,-2) -- I wouldn't bother to add same pos change for murky that use same model as heavy_swat
			end	
		end
		
		if self._unit:base()._tweak_table == "zeal_heavy_swat" and faction == "murkywater"  then
			effect_pos = Vector3(0,0,-2)
		end
	
		if (self._unit:base()._tweak_table == "city_swat" or self._unit:base()._tweak_table == "zeal_swat") and faction == "murkywater" then
			effect_pos = Vector3(0,1,-2)
		end
	
		if faction == "russia" then
			effect_pos = Vector3(0,-1,-3)
		end
	end
	
	if SC and table.contains(joker_effect_table_eye_effects, joker_effect) then
		local unit = self._unit:base()._tweak_table
		local unit_name = self._unit:name()
		
		if table.contains(resmod_units_no_gear, unit) and not table.contains(resmod_hrt_exclude_list, unit_name) then
			effect_pos = effect_pos_no_gear
		end
		
		if table.contains(resmod_murky_no_gear, unit_name) then
			effect_pos = effect_pos_no_gear
		end
		
		if table.contains(resmod_units_low, unit_name) then
			effect_pos = effect_pos_low
		end
	end
	
	effect_id_string_data[1] = joker_effect_id_string
	effect_id_string_data[2] = attach_to_unit
	effect_id_string_data[3] = effect_pos
	
	return effect_id_string_data
end

function CopBase:Joker_Effect_converted_enemy_effect(state)
	if state then
		local effect_data = self:get_Joker_Effect()
		local effect_id = effect_data[1]
		local attach_to_unit = effect_data[2]
		local effect_pos = effect_data[3]
		
		self._convert_effect = World:effect_manager():spawn({
			effect = effect_id,
			parent = attach_to_unit,
			position = effect_pos
		})
	else
		if self._convert_effect then
			World:effect_manager():fade_kill(self._convert_effect)
		end
	end
end